/* Panasonic mappers */

/* --- Panasonic PAC
	8KB SRAM cart supported by Hydlide 3, ..?
*/
static const char* pac_fn="sram.pac";
static u8* cartsram[2];

/* 8KB SRAM in $0000-$1fff subregion if $1ffe=$4d and $1fff=$69 */
u8 __fastcall mapread_pac(u16 a)
{
	int slot=~pslot>>(a>>13&6)&1;
	a&=0x1fff;
	
	if (a>0x1ffd) return cartsram[slot][a];
	else if ((cartsram[slot][0x1ffe]|cartsram[slot][0x1fff]<<8)==0x694d) return cartsram[slot][a];
	
	return UNMAPPED;
}

void __fastcall mapwrite_pac(u16 a,u8 v)
{
	int slot=~pslot>>(a>>13&6)&1;
	a&=0x1fff;
	
	if (a>0x1ffd) cartsram[slot][a]=v;
	else if ((cartsram[slot][0x1ffe]|cartsram[slot][0x1fff]<<8)==0x694d) cartsram[slot][a]=v;
}

static void mapclean_pac(int slot)
{
	if (cartsram[slot]) {
		memmove(cartsram[slot]+16,cartsram[slot],0x1ffe);
		memcpy(cartsram[slot],"PAC2 BACKUP DATA",16);
	}
	
	sram_save(slot,cartsram[slot],8206,pac_fn);
}

static void mapinit_pac(int slot)
{
	int i;
	
	if (mapclean[slot]==mapclean_nothing) {
		if (sram_load(slot,&cartsram[slot],8206,pac_fn,0xff)) {
			memmove(cartsram[slot],cartsram[slot]+16,0x1ffe);
			cartsram[slot][0x1ffe]=cartsram[slot][0x1fff]=0xff;
		}
		cartsramsize[slot]=0x2000; /* mem size */
		mapclean[slot]=mapclean_pac;
	}
	
	for (i=0;i<8;i+=2) {
		mapwrite_std[slot+1][i]=mapwrite_pac;
		mapread_std[slot+1][i]=mapread_pac;
	}
}
